@echo off

rem  -------------------------------------------------------------------------
rem
rem  File Name : update30.bat
rem
rem  Remarks   : This batch file updates a package from a specified version
rem              to a specified version.
rem
rem  SYNTAX    : update30 directory package oldver newver [L or S or P]
rem
rem  Programmer: D. Tsitrelis  02/03/94
rem              Dale Keiper   06/28/94
rem              D. Tsitrelis  01/15/95
rem
rem  -------------------------------------------------------------------------
rem

rem Display header

echo 
echo  update30.bat
echo  Copyright (c) Genus Microprogramming, Inc. 1988-94. All Rights Reserved.
echo 

rem  -------------------------------------------------------------------------
     :PARMS
rem  -------------------------------------------------------------------------

     if "%1"=="?"  goto SYNTAX

     if "%1"==""   goto SYNTAX
     if "%2"==""   goto SYNTAX
     if "%3"==""   goto SYNTAX
     if "%4"==""   goto SYNTAX
     if "%5"=="L"  goto ENVIRONMENT
     if "%5"=="l"  goto ENVIRONMENT
     if "%5"=="S"  goto ENVIRONMENT
     if "%5"=="s"  goto ENVIRONMENT
     if "%5"=="P"  goto ENVIRONMENT
     if "%5"=="p"  goto ENVIRONMENT

     goto SYNTAX

rem  -------------------------------------------------------------------------
     :ENVIRONMENT
rem  -------------------------------------------------------------------------

     set GXLIB=%2
     set GXOLDVER=%3
     set GXORIGVER=%3
     set GXNEWVER=%4
     set GXPACKAGE=%5

rem  Adjust to use upper case to simplify comparisons

     if "%GXPACKAGE%"=="L" goto TESTPACKAGE
     if "%GXPACKAGE%"=="l" goto ADJUSTLIBCASE
     if "%GXPACKAGE%"=="S" goto TESTPACKAGE
     if "%GXPACKAGE%"=="s" goto ADJUSTSRCCASE
     if "%GXPACKAGE%"=="P" goto TESTPACKAGE
     if "%GXPACKAGE%"=="p" goto ADJUSTPMCASE

:ADJUSTLIBCASE

     set  GXPACKAGE=L
     goto TESTPACKAGE

:ADJUSTSRCCASE

     set  GXPACKAGE=S
     goto TESTPACKAGE

:ADJUSTPMCASE

     set  GXPACKAGE=P
     goto TESTPACKAGE

rem  -------------------------------------------------------------------------
     :TESTPACKAGE
rem  -------------------------------------------------------------------------

     if "%GXPACKAGE%"=="L" goto MSGL
     if "%GXPACKAGE%"=="S" goto MSGS
     if "%GXPACKAGE%"=="P" goto MSGP

     goto ERROR

rem  -------------------------------------------------------------------------
     :MSGL
rem  -------------------------------------------------------------------------

echo 
echo  Patching library files for %GXLIB% from v%GXOLDVER% to v%GXNEWVER%
echo 

     goto START

rem  -------------------------------------------------------------------------
     :MSGS
rem  -------------------------------------------------------------------------

echo 
echo  Patching source code files for %GXLIB% from v%GXOLDVER% to v%GXNEWVER%
echo 

     goto START

rem  -------------------------------------------------------------------------
     :MSGP
rem  -------------------------------------------------------------------------

echo 
echo  Patching protected mode files for %GXLIB% from v%GXOLDVER% to v%GXNEWVER%
echo 

rem  -------------------------------------------------------------------------
     :START
rem  -------------------------------------------------------------------------

     if "%GXLIB%"=="GX"  goto GX300
     if "%GXLIB%"=="gx"  goto GX300
     if "%GXLIB%"=="TX"  goto TX300
     if "%GXLIB%"=="tx"  goto TX300
     if "%GXLIB%"=="FX"  goto FX300
     if "%GXLIB%"=="fx"  goto FX300
     if "%GXLIB%"=="PCX" goto PCX600
     if "%GXLIB%"=="pcx" goto PCX600
     if "%GXLIB%"=="GR"  goto GR300
     if "%GXLIB%"=="gr"  goto GR300
     if "%GXLIB%"=="PR"  goto PR150
     if "%GXLIB%"=="pr"  goto PR150
     if "%GXLIB%"=="GIF" goto GIF150
     if "%GXLIB%"=="gif" goto GIF150

     goto SYNTAX

rem  -------------------------------------------------------------------------
     :GX300
rem  -------------------------------------------------------------------------

     if not "%GXOLDVER%"=="3.00" goto GX301

     if not "%GXPACKAGE%"=="S" goto GX300LP

     md %1\gx\asm\bl286    > nul
     md %1\gx\asm\bcl      > nul
     md %1\gx\asm\stub\bcl > nul

     :GX300LP

     patch %1 gx301%GXPACKAGE%.RTP
     if not errorlevel 0 goto ERROR

     if "%GXNEWVER%"=="3.01" goto SUCCESS

     set GXOLDVER=3.01

rem  -------------------------------------------------------------------------
     :GX301
rem  -------------------------------------------------------------------------

     if not "%GXOLDVER%"=="3.01" goto GX302

     if not "%GXPACKAGE%"=="S" goto GX301LP

     md %1\gx\asm\bc286    > nul
     md %1\gx\asm\pb       > nul
     md %1\gx\asm\stub\pb  > nul

     :GX301LP

     patch %1 gx302%GXPACKAGE%.RTP
     if not errorlevel 0 goto ERROR

     if "%GXNEWVER%"=="3.02" goto SUCCESS

     set GXOLDVER=3.02

rem  -------------------------------------------------------------------------
     :GX302
rem  -------------------------------------------------------------------------

     if not "%GXOLDVER%"=="3.02" goto GX303

     if not "%GXPACKAGE%"=="S" goto GX302LP

     md %1\gx\asm\tb286    > nul

     :GX302LP

     patch %1 gx303%GXPACKAGE%.RTP
     if not errorlevel 0 goto ERROR

     if "%GXNEWVER%"=="3.03" goto SUCCESS

     set GXOLDVER=3.03

rem  -------------------------------------------------------------------------
     :GX303
rem  -------------------------------------------------------------------------

     goto SUCCESS

rem  -------------------------------------------------------------------------
     :FX300
rem  -------------------------------------------------------------------------

     if not "%GXOLDVER%"=="3.00" goto FX301

     if not "%GXPACKAGE%"=="S" goto FX300LP

     md %1\fx\asm\bc286    > nul
     md %1\fx\asm\bcl      > nul
     md %1\fx\asm\bl286    > nul
     md %1\fx\asm\bp286    > nul
     md %1\fx\asm\ex286    > nul
     md %1\fx\asm\pl286    > nul
     md %1\fx\asm\pl286\cl > nul
     md %1\fx\asm\pl286\cm > nul
     md %1\fx\asm\pl286\cs > nul
     md %1\fx\asm\rs286    > nul
     md %1\fx\asm\rs286\cl > nul
     md %1\fx\asm\rs286\cm > nul
     md %1\fx\asm\rs286\cs > nul
     md %1\fx\asm\stub     > nul
     md %1\fx\asm\stub\bc  > nul
     md %1\fx\asm\stub\bc7 > nul
     md %1\fx\asm\stub\bcl > nul
     md %1\fx\asm\stub\cl  > nul
     md %1\fx\asm\stub\cm  > nul
     md %1\fx\asm\stub\cs  > nul
     md %1\fx\asm\stub\pb  > nul
     md %1\fx\asm\stub\tp  > nul

     :FX300LP

     patch %1 fx301%GXPACKAGE%.RTP

     if not errorlevel 0 goto ERROR

     if "%GXNEWVER%"=="3.01" goto SUCCESS

     set GXOLDVER=3.01

rem  -------------------------------------------------------------------------
     :FX301
rem  -------------------------------------------------------------------------

     goto SUCCESS

rem  -------------------------------------------------------------------------
     :PR150
rem  -------------------------------------------------------------------------

     if not "%GXOLDVER%"=="1.50" goto PR151

     if not "%GXPACKAGE%"=="S" goto PR150LP

     md %1\pr\asm\bl286    > nul
     md %1\pr\asm\bcl      > nul

     :PR150LP

     patch %1 pr151%GXPACKAGE%.RTP
     if not errorlevel 0 goto ERROR

     if "%GXNEWVER%"=="1.51" goto SUCCESS

     set GXOLDVER=1.51

rem  -------------------------------------------------------------------------
     :PR151
rem  -------------------------------------------------------------------------

     if not "%GXOLDVER%"=="1.51" goto PR152

     if not "%GXPACKAGE%"=="S" goto PR151LP

     md %1\pr\asm\bc286    > nul
     md %1\pr\asm\pb       > nul

     :PR151LP

     patch %1 pr152%GXPACKAGE%.RTP
     if not errorlevel 0 goto ERROR

     if "%GXNEWVER%"=="1.52" goto SUCCESS

     set GXOLDVER=1.52

rem  -------------------------------------------------------------------------
     :PR152
rem  -------------------------------------------------------------------------

     goto SUCCESS

rem  -------------------------------------------------------------------------
     :TX300
rem  -------------------------------------------------------------------------

     if not "%GXOLDVER%"=="3.00" goto TX301

     patch %1 tx301%GXPACKAGE%.RTP

     if not errorlevel 0 goto ERROR

     if not "%GXPACKAGE%"=="L" goto TX301SRCTEST

     echo copy %%1 %%2     >  gxmove.bat
     echo del  %%1         >> gxmove.bat

     md %1\fontsae         > nul
     md %1\fontsfn         > nul
     md %1\fontsoz         > nul

     echo 
     echo  Copying fonts A-E to new directory
     echo 

     for %%i in (%1\fonts\a????_??.gft) do call gxmove %%i %1\fontsae
     for %%i in (%1\fonts\b????_??.gft) do call gxmove %%i %1\fontsae
     for %%i in (%1\fonts\c????_??.gft) do call gxmove %%i %1\fontsae
     for %%i in (%1\fonts\d????_??.gft) do call gxmove %%i %1\fontsae
     for %%i in (%1\fonts\e????_??.gft) do call gxmove %%i %1\fontsae

     echo 
     echo  Copying fonts F-N to new directory
     echo 

     for %%i in (%1\fonts\f????_??.gft) do call gxmove %%i %1\fontsfn
     for %%i in (%1\fonts\g????_??.gft) do call gxmove %%i %1\fontsfn
     for %%i in (%1\fonts\h????_??.gft) do call gxmove %%i %1\fontsfn
     for %%i in (%1\fonts\i????_??.gft) do call gxmove %%i %1\fontsfn
     for %%i in (%1\fonts\j????_??.gft) do call gxmove %%i %1\fontsfn
     for %%i in (%1\fonts\k????_??.gft) do call gxmove %%i %1\fontsfn
     for %%i in (%1\fonts\l????_??.gft) do call gxmove %%i %1\fontsfn
     for %%i in (%1\fonts\m????_??.gft) do call gxmove %%i %1\fontsfn
     for %%i in (%1\fonts\n????_??.gft) do call gxmove %%i %1\fontsfn

     echo 
     echo  Copying fonts O-Z to new directory
     echo 

     for %%i in (%1\fonts\o????_??.gft) do call gxmove %%i %1\fontsoz
     for %%i in (%1\fonts\p????_??.gft) do call gxmove %%i %1\fontsoz
     for %%i in (%1\fonts\q????_??.gft) do call gxmove %%i %1\fontsoz
     for %%i in (%1\fonts\r????_??.gft) do call gxmove %%i %1\fontsoz
     for %%i in (%1\fonts\s????_??.gft) do call gxmove %%i %1\fontsoz
     for %%i in (%1\fonts\t????_??.gft) do call gxmove %%i %1\fontsoz
     for %%i in (%1\fonts\u????_??.gft) do call gxmove %%i %1\fontsoz
     for %%i in (%1\fonts\v????_??.gft) do call gxmove %%i %1\fontsoz
     for %%i in (%1\fonts\w????_??.gft) do call gxmove %%i %1\fontsoz
     for %%i in (%1\fonts\x????_??.gft) do call gxmove %%i %1\fontsoz
     for %%i in (%1\fonts\y????_??.gft) do call gxmove %%i %1\fontsoz
     for %%i in (%1\fonts\z????_??.gft) do call gxmove %%i %1\fontsoz

     del gxmove.bat

     if "%GXNEWVER%"=="3.01" goto SUCCESS

     set GXOLDVER=3.01

:TX301SRCTEST

     if not "%GXPACKAGE%"=="S" goto TX301PMTEST

     md %1\tx\asm\bl286    > nul
     md %1\tx\asm\bcl      > nul
     md %1\tx\asm\stub\bcl > nul

     if "%GXNEWVER%"=="3.01" goto SUCCESS

     set GXOLDVER=3.01

:TX301PMTEST

     if not "%GXPACKAGE%"=="P" goto TX301

     if "%GXNEWVER%"=="3.01" goto SUCCESS

     set GXOLDVER=3.01

rem  -------------------------------------------------------------------------
     :TX301
rem  -------------------------------------------------------------------------

     if not "%GXOLDVER%"=="3.01" goto TX302

     if not "%GXPACKAGE%"=="S" goto TX301LP

     md %1\tx\asm\pb       > nul

     :TX301LP

     patch %1 tx302%GXPACKAGE%.RTP
     if not errorlevel 0 goto ERROR

     if "%GXNEWVER%"=="3.02" goto SUCCESS

     set GXOLDVER=3.02

rem  -------------------------------------------------------------------------
     :TX302
rem  -------------------------------------------------------------------------

     goto SUCCESS

rem  -------------------------------------------------------------------------
     :PCX600
rem  -------------------------------------------------------------------------

     if not "%GXOLDVER%"=="6.00" goto PCX601

     if not "%GXPACKAGE%"=="S" goto PCX600LP

     md %1\pcx\asm\pb       > nul
     md %1\pcx\asm\bcl      > nul
     md %1\pcx\asm\bc286    > nul
     md %1\pcx\asm\bl286    > nul
     md %1\pcx\asm\ex286    > nul
     md %1\pcx\asm\stub\bcl > nul
     md %1\pcx\asm\stub\pb  > nul
     md %1\pcx\asm\stub\tp  > nul

     :PCX600LP

     patch %1 pcx601%GXPACKAGE%.RTP

     if not errorlevel 0 goto ERROR

     if "%GXNEWVER%"=="6.01" goto SUCCESS

     set GXOLDVER=6.01


rem  -------------------------------------------------------------------------
     :PCX601
rem  -------------------------------------------------------------------------

     goto SUCCESS

rem  -------------------------------------------------------------------------
     :GIF150
rem  -------------------------------------------------------------------------

     if not "%GXOLDVER%"=="1.50" goto GIF151

     if not "%GXPACKAGE%"=="S" goto GIF150LP

     md %1\gif\asm\pb       > nul
     md %1\gif\asm\bcl      > nul
     md %1\gif\asm\bc286    > nul
     md %1\gif\asm\bl286    > nul

     :GIF150LP

     patch %1 gif151%GXPACKAGE%.RTP

     if not errorlevel 0 goto ERROR

     if "%GXNEWVER%"=="1.51" goto SUCCESS

     set GXOLDVER=1.51



rem  -------------------------------------------------------------------------
     :GIF151
rem  -------------------------------------------------------------------------

     goto SUCCESS

rem  -------------------------------------------------------------------------
     :GR300
rem  -------------------------------------------------------------------------

     if not "%GXOLDVER%"=="3.00" goto GR301

     if not "%GXPACKAGE%"=="S" goto GR300LP

     md %1\gr\asm\pb       > nul

     :GR300LP


     patch %1 gr301%GXPACKAGE%.RTP

     if not errorlevel 0 goto ERROR

     if "%GXNEWVER%"=="3.01" goto SUCCESS

     set GXOLDVER=3.01

rem  -------------------------------------------------------------------------
     :GR301
rem  -------------------------------------------------------------------------

     goto SUCCESS

rem  -------------------------------------------------------------------------
     :SUCCESS
rem  -------------------------------------------------------------------------

rem  Display success message

echo 
echo  %GXLIB% files v%GXORIGVER% were patched successfully to v%GXNEWVER%.
echo 

     goto END

rem  -------------------------------------------------------------------------
     :ERROR
rem  -------------------------------------------------------------------------

rem  Display error message

echo 
echo 
echo  Error building patch for %GXLIB% from v%GXOLDVER% to v%GXNEWVER%...
echo 

     goto END

rem  -------------------------------------------------------------------------
     :SYNTAX
rem  -------------------------------------------------------------------------

echo 
echo 
echo  SYNTAX    : update30 DIR LIBRARY OLDVER NEWVER [S or L or P]
echo 
echo          where DIR            = directory package is installed at
echo                LIBRARY        = library (GX,TX,FX,PCX,GR,GIF,PR)
echo                OLDVER         = old version
echo                NEWVER         = new version
echo                [S or L or P]  = patch the [S]ource code or [L]ibrary or
echo                                 [P]rotected mode
echo 
echo  Example   : To apply the source code patch to convert GX Kernel v3.00
echo              to v3.05, type the following:
echo 
echo              update30 C:\GENUS GX 3.00 3.05 S
echo 
     goto END

rem  -------------------------------------------------------------------------
     :END
rem  -------------------------------------------------------------------------

     set GXLIB=
     set GXOLDVER=
     set GXORIGVER=
     set GXNEWVER=
     set GXPACKAGE=

     exit

